{ lib, stdenv
, fetchFromGitHub

, cmake
, ninja
, gettext
, wrapGAppsHook
, pkg-config

, glib
, gsettings-desktop-schemas
, gtk3
, libsndfile
, libxml2
, libzip
, pcre
, poppler
, portaudio
, zlib
, librsvg
# plugins
, withLua ? true, lua
}:

stdenv.mkDerivation rec {
  pname = "xournalpp";
  version = "2021-07-10";

  src = fetchFromGitHub {
    owner = "xournalpp";
    repo = pname;
    rev = "1a60605e7ccfe1d46162355825dd19f27d931db4";
    sha256 = "sha256-l+V/MsqMYmsozUVIuHmYL60QVoH8ADXUR/SJOjh9LTQ=";
  };

  nativeBuildInputs = [ cmake ninja gettext pkg-config wrapGAppsHook ];
  buildInputs =
    [ glib
      gsettings-desktop-schemas
      gtk3
      libsndfile
      libxml2
      libzip
      pcre
      poppler
      portaudio
      zlib
      librsvg
    ]
    ++ lib.optional withLua lua;

  buildFlags = "translations";

  hardeningDisable = [ "format" ];

  meta = with lib; {
    description = "Xournal++ is a handwriting Notetaking software with PDF annotation support";
    homepage    = "https://xournalpp.github.io/";
    license     = licenses.gpl2Plus;
    maintainers = with maintainers; [ andrew-d sikmir ];
    platforms   = platforms.linux;
  };
}
